import { reactive } from 'vue'
import axios from 'axios'
import { handleMsg, sendSub } from './utils/websocket'

const state = reactive({
  token: '',
  session: '',
  loggedIn: false,
  ws: null,
  events: [],
  rosters: [],
  matches: [],
  casters: [],
  hosts: [],
  streams: [],
})

const methods = {
  authenticate: async () => {
    return axios.post('http://localhost:5000/api/v1', {
      token: state.token,
    })
      .then((res) => {
        state.session = res.data.session
        state.loggedIn = true
        return true
      })
  },
  connect: (uri) => {
    state.ws = new WebSocket(`${uri}/${state.session}`)
    state.ws.onopen = () => {
      sendSub(state.ws)
    }
    state.ws.onmessage = (e) => {
      const data = JSON.parse(e.data)
      handleMsg(data)
    }
  }
}

export default {
  state,
  methods,
}